------------------------------------------------------------------------------
--	Events.lua
--  EwokBaconBits
------------------------------------------------------------------------------
local m_MyGlobals : table = {}

function GetMyGlobals( MyGlobalsRef : table )
    MyGlobalsRef.MyGlobals = m_MyGlobals;
end



-- function OnPlayerTurnActivated(player, isFirstTimeThisTurn)
	-- if (isFirstTimeThisTurn and Game.GetLocalPlayer() == player) then
		-- pPlayer = Players[player];
	-- end
-- end


function OnUnitRemovedFromMap( playerID: number, unitID : number )
	local pPlayer = Players[playerID];
	local pUnit = m_MyGlobals.curUnit;
	local MyGlobalsRef : table = {};
	LuaEvents.GetMyGlobals(MyGlobalsRef);
	

	-- local pUnit = pPlayer:GetUnits():FindID(unitID);
	-- CREATE ARMY GROUP
	-------------------------------------------
	if (m_MyGlobals.curCreateArmyGroup) then
		local FormationType = GameInfo.Units[pUnit:GetUnitType()].FormationClass;
		pEras = pPlayer:GetEras();
		curEra = pEras:GetEra();
		if FormationType == "FORMATION_CLASS_LAND_COMBAT" or FormationType == "FORMATION_CLASS_SUPPORT" then
			if curEra == 2 or curEra == 3 then
				eraArmy = "UNIT_MEDIEVAL_ARMY";
			elseif curEra == 1 then
				eraArmy = "UNIT_CLASSICAL_ARMY";
			elseif curEra == 4 or curEra == 5 then
				eraArmy = "UNIT_INDUSTRIAL_ARMY";
			elseif curEra > 6 then
				eraArmy = "UNIT_POSTMODERN_ARMY";
			else 
				eraArmy = "UNIT_ANCIENT_ARMY";
			end
		end
		if FormationType == "FORMATION_CLASS_NAVAL" then
			if curEra == 3 then
				eraArmy = "UNIT_RENAISSANCE_FLEET";
			elseif curEra == 4 or curEra == 5 then
				eraArmy = "UNIT_INDUSTRIAL_FLEET";
			elseif curEra > 6 then
				eraArmy = "UNIT_POSTMODERN_FLEET";
			else 
				eraArmy = "UNIT_CLASSICAL_FLEET";
			end
		end
		newUnitP = UnitManager.InitUnit(playerID, eraArmy, m_MyGlobals.curPlot:GetX(), m_MyGlobals.curPlot:GetY());
		newUnit = newUnitP:GetID();
		x = newUnitP:GetX();
		y = newUnitP:GetY();
		experience = pUnit:GetExperience();
		experience = experience:GetExperiencePoints();
		--promotions = m_MyGlobals.curPromotions;
		MyGlobalsRef.MyGlobals.curCreateArmyGroup = false;

		--damage = pUnit:GetDamage();
		--newUnitP:SetDamage(damage);
		-------------------------------
		newArmyGroup = {newUnit};
		unitType = GameInfo.Units[pUnit:GetUnitType()].UnitType;
		newArmyUnit = {
			unitType = unitType,
			xp = experience,
		}
		-- GET NAME AND PROMOTIONS ALSO
		table.insert(newArmyGroup, 2, newArmyUnit);
		table.insert(ExposedMembers.armyGroups, 1, newArmyGroup);

		armyMoveTracker = {
			iUnit = newUnit,
			x = x,
			y = y,
		}
		table.insert(ExposedMembers.armyTracker, 1, armyMoveTracker);
	end
	-- DEPLOY ARMY GROUP
	-------------------------------------------
	if (m_MyGlobals.curDeployArmyGroup) then
		for i, armyTrackerItem in ipairs(ExposedMembers.armyTracker) do
				-- Looping through All Army Groups
				rightGroup = true;
				iUnitCheck = armyTrackerItem.iUnit;
				--iUnitCheck = pUnitCheck:GetID();
				if iUnitCheck == unitID then
					previousX = armyTrackerItem.x;
					previousY = armyTrackerItem.y;
					table.remove(ExposedMembers.armyTracker, i);
					validUnit = true;
				end	
		end
		MyGlobalsRef.MyGlobals.curDeployArmyGroup = false;
		for i, armyGroupItem in ipairs(ExposedMembers.armyGroups) do
				-- Looping through All Army Groups
				rightGroup = true;
				for j, armyUnitItem in ipairs(armyGroupItem) do
						if j == 1 and unitID ~= armyUnitItem then
							--skip
							rightGroup = false;
						end
						-- Looping through all ArmyUnits
						if j >= 2 and rightGroup then
							deployedUnit = UnitManager.InitUnit(playerID, armyUnitItem.unitType, m_MyGlobals.curPlot:GetX(), m_MyGlobals.curPlot:GetY());
							pExperience = deployedUnit:GetExperience();
							pExperience:ChangeExperience(armyUnitItem.xp);
							--for _, promotion in pairs(armyUnitItem.promotions) do
							--	promotionType = GameInfo.UnitPromotions[promotion].UnitPromotionType;
							--	pExperience:SetPromotion(promotion);
							--end
							--damage = pUnit:GetDamage();
							--deployedUnit:SetDamage(damage);
						end
				end
			end
			for i, armyGroupItem in ipairs(ExposedMembers.armyGroups) do
				rightGroup = true;
				for j, armyUnitItem in ipairs(armyGroupItem) do
						if j == 1 and unitID ~= armyUnitItem then
							--skip
							rightGroup = false;
						end
						if j >= 2 and rightGroup then
							table.remove(ExposedMembers.armyGroups, i);
						end
				end
			end
	end
	
	-- FORCED DEPLOY ARMY GROUP
	-------------------------------------------
	if ((m_MyGlobals.curDeployArmyGroup == false) and (m_MyGlobals.curJoinArmyGroup == false) and (m_MyGlobals.curCreateArmyGroup == false)) then
		validUnit = false;
		for i, armyTrackerItem in ipairs(ExposedMembers.armyTracker) do
				-- Looping through All Army Groups
				rightGroup = true;
				iUnitCheck = armyTrackerItem.iUnit;
				--iUnitCheck = pUnitCheck:GetID();
				if iUnitCheck == unitID then
					previousX = armyTrackerItem.x;
					previousY = armyTrackerItem.y;
					table.remove(ExposedMembers.armyTracker, i);
					validUnit = true;
				end	
		end
		if validUnit then
			for i, armyGroupItem in ipairs(ExposedMembers.armyGroups) do
					-- Looping through All Army Groups
					rightGroup = true;
					for j, armyUnitItem in ipairs(armyGroupItem) do
							if j == 1 and unitID ~= armyUnitItem then
								--skip
								rightGroup = false;
							end
							-- Looping through all ArmyUnits
							if j >= 2 and rightGroup then
								--deployedUnit = UnitManager.InitUnit(playerID, armyUnitItem.unitType, m_MyGlobals.curPlot:GetX(), m_MyGlobals.curPlot:GetY());
								deployedUnit = UnitManager.InitUnitValidAdjacentHex(playerID, armyUnitItem.unitType, previousX, previousY, 1);
								deployedUnit  = pPlayer:GetUnits():FindID(deployedUnit );
								pExperience = deployedUnit:GetExperience();
								pExperience:ChangeExperience(armyUnitItem.xp);
								--for _, promotion in pairs(armyUnitItem.promotions) do
								--	promotionType = GameInfo.UnitPromotions[promotion].UnitPromotionType;
								--	pExperience:SetPromotion(promotion);
								--end
								deployedUnit:SetDamage(50);
								table.remove(ExposedMembers.armyGroups, i);
							end
					end
			end
		end
		for i, armyGroupItem in ipairs(ExposedMembers.armyGroups) do
			if i == 1 and unitID ~= armyUnitItem then
				--skip
				rightGroup = false;
			end
			if i >= 2 and rightGroup then
				table.remove(ExposedMembers.armyGroups, i);
			end
		end
	end
	-- JOIN ARMY GROUP
	-------------------------------------------
	if (m_MyGlobals.curJoinArmyGroup) then
		MyGlobalsRef.MyGlobals.curJoinArmyGroup = false;
		unitType = GameInfo.Units[pUnit:GetUnitType()].UnitType;
		experience = pUnit:GetExperience();
		experience = experience:GetExperiencePoints();
		--promotions = m_MyGlobals.curPromotions;
		
		--joinDamage = pUnit:GetDamage();
		--newDamage = m_MyGlobals.curRequestpUnit:GetDamage();
		--damage = (newDamage * joinDamage) / 2;
		--m_MyGlobals.curRequestpUnit:SetDamage(damage);
		--for _, promotion in pairs(promotions) do
		--	promotionType = GameInfo.UnitPromotions[promotion].UnitPromotionType;
		--end
		newArmyUnit = {
			unitType = unitType,
			xp = experience,
		}
		newArmyGroup = {m_MyGlobals.curRequestUnitID};
		table.insert(newArmyGroup, 2, newArmyUnit);
		table.insert(ExposedMembers.armyGroups, 1, newArmyGroup);
	end
end

function OnUnitMoved(player, unit, x, y, locallyVisible, stateChange)
	local pPlayer = Players[player];
	local pUnit = pPlayer:GetUnits():FindID(unit);
	local unitType = GameInfo.Units[pUnit:GetType()].UnitType;
	local iUnit = pUnit:GetID();
	if unitType == "UNIT_ANCIENT_ARMY" or unitType == "UNIT_MEDIEVAL_ARMY" or unitType == "UNIT_CLASSICAL_ARMY" or unitType == "UNIT_INDUSTRIAL_ARMY" or unitType == "UNIT_POSTMODERN_ARMY" or unitType == "UNIT_CLASSICAL_FLEET" or unitType == "UNIT_RENASSIANCE_FLEET" or unitType == "UNIT_INDUSTRIAL_FLEET" or unitType == "UNIT_POSTMODERN_FLEET" then
		armyMoveTracker = {
			iUnit = iUnit,
			x = x,
			y = y,
		}
		
		for i, armyTrackerItem in ipairs(ExposedMembers.armyTracker) do
				-- Looping through All Army Groups
				if armyTrackerItem.iUnit == iUnit then
					table.remove(ExposedMembers.armyTracker, i);
				end	
		end
		table.insert(ExposedMembers.armyTracker, 1, armyMoveTracker);
	end
end


--function OnPlayerTurnActivated(player, isFirstTimeThisTurn)
		-- local pPlayer = Players[player];
		-- if (isFirstTimeThisTurn and pPlayer:IsHuman() == false and pPlayer ~= nil and Game.GetCurrentGameTurn() ~= 0 and pPlayer:IsMajor()) then
			-- local MyGlobalsRef : table = {};
			-- LuaEvents.GetMyGlobals(MyGlobalsRef);
			-- print("AI TURN ACTIVATED");
			-- pDiplomacy = pPlayer:GetDiplomacy();
			-- atWar = false;
			-- for i, pOtherPlayer in ipairs(PlayerManager.GetAliveMajors()) do			
				-- local iOtherPlayer = pOtherPlayer:GetID();
				-- if pDiplomacy:IsAtWarWith(iOtherPlayer) then
					-- atWar = true;
					-- break;
				-- end
			-- end
		
			-- local playerUnits = pPlayer:GetUnits();
			-- for i, unit in playerUnits:Members() do
				-- if "UNIT_ANCIENT_ARMY" == unitTypeName or "UNIT_CLASSICAL_ARMY" == unitTypeName or "UNIT_MEDIEVAL_ARMY" == unitTypeName or "UNIT_INDUSTRIAL_ARMY" == unitTypeName or "UNIT_POSTMODERN_ARMY" == unitTypeName then
					-- for direction = 0, DirectionTypes.NUM_DIRECTION_TYPES - 1, 1 do
						-- adjacentPlot = Map.GetAdjacentPlot(unit:GetX(), unit:GetY(), direction);
						-- rangeTwoAdjacentPlot = Map.GetAdjacentPlot(adjacentPlot:GetX(), adjacentPlot:GetY(), direction);
						-- local barbarians = PlayerManager.GetAliveBarbarians()
						-- local barbarianUnits = barbarians[1]:GetUnits()
						-- for i, pOtherPlayer in ipairs(PlayerManager.GetAliveMajors()) do			
							-- local iOtherPlayer = pOtherPlayer:GetID();
							-- if pDiplomacy:IsAtWarWith(iOtherPlayer) then
								-- local iOtherPlayerUnits = iOtherPlayer:GetUnits();
								-- for i, poUnit in iOtherPlayerUnits:Members() do
									-- if (poUnit:GetY() == rangeTwoAdjacentPlot:GetX() and poUnit:GetX() == rangeTwoAdjacentPlot:GetX()) then
										--deploy
										-- MyGlobalsRef.MyGlobals.curCreateArmyGroup = false;
										-- MyGlobalsRef.MyGlobals.curDeployArmyGroup = true;
										-- MyGlobalsRef.MyGlobals.curJoinArmyGroup = false;
										-- MyGlobalsRef.MyGlobals.curUnit = pUnit;
										-- MyGlobalsRef.MyGlobals.curPlot = Map.GetPlot( pUnit:GetX(), pUnit:GetY() );
										-- UnitManager.RequestCommand( pUnit, UnitCommandTypes.DELETE );
									-- end
								-- end
							-- end
						-- end
						-- for i, barbUnit in barbarianUnits:Members() do
									-- if (barbUnit:GetY() == rangeTwoAdjacentPlot:GetX() and barbUnit:GetX() == rangeTwoAdjacentPlot:GetX()) then
										--deploy
										-- MyGlobalsRef.MyGlobals.curCreateArmyGroup = false;
										-- MyGlobalsRef.MyGlobals.curDeployArmyGroup = true;
										-- MyGlobalsRef.MyGlobals.curJoinArmyGroup = false;
										-- MyGlobalsRef.MyGlobals.curUnit = pUnit;
										-- MyGlobalsRef.MyGlobals.curPlot = Map.GetPlot( pUnit:GetX(), pUnit:GetY() );
										-- UnitManager.RequestCommand( pUnit, UnitCommandTypes.DELETE );
									-- end
						-- end
					-- end
				-- end
			-- end
				-- if atWar == false then
					-- print("Not At War");
					-- pEras = pPlayer:GetEras();
					-- curEra = pEras:GetEra();
					-- if curEra == 2 or curEra == 3 then
						-- eraArmy = "UNIT_MEDIEVAL_ARMY";

					-- elseif curEra == 1 then
						-- eraArmy = "UNIT_CLASSICAL_ARMY";
					-- elseif curEra == 4 or curEra == 5 then
						-- eraArmy = "UNIT_MEDIEVAL_ARMY";
					-- elseif curEra == 5 or curEra == 6 then
						-- eraArmy = "UNIT_INDUSTRIAL_ARMY";
					-- elseif curEra > 6 then
						-- eraArmy = "UNIT_POSTMODERN_ARMY";
					-- else 
						-- eraArmy = "UNIT_ANCIENT_ARMY";
					-- end
					-- local capitalCity = pPlayer:GetCities():GetCapitalCity();
					-- if capitalCity ~= nil then
						-- capX = capitalCity:GetX();
						-- print(capX);
						-- capY = capitalCity:GetY();
						-- print(capY);
						-- newUnitP = UnitManager.InitUnit(player, eraArmy, capX, capY);
						-- newUnit = newUnitP:GetID();
						-- x = newUnitP:GetX();
						-- y = newUnitP:GetY();
						--promotions = m_MyGlobals.curPromotions;
						-- MyGlobalsRef.MyGlobals.curCreateArmyGroup = false;

						-- newArmyGroup = {newUnit};
						-- unitNumberMilitary = math.random(1,5);
						-- unitNumberSupport = math.random(1,5);
						-- print(unitNumberMilitary);
						-- print(unitNumberSupport);
						-- for i=1,unitNumberMilitary do
							-- print(i);
							-- ranXP = math.random(5,60);
							-- randType = math.random(1,5);
							-- if curEra == 2 or curEra == 3 then
								-- if randType == 1 then
									-- ranUnitType = "UNIT_PIKEMAN";
								-- elseif randType == 2 then
									-- ranUnitType = "UNIT_KNIGHT";
								-- elseif randType == 3 then
									-- ranUnitType = "UNIT_CROSSBOWMAN";
								-- elseif randType == 4 then
									-- ranUnitType = "UNIT_CATAPULT";
								-- else
									-- ranUnitType = "UNIT_HORSEMAN";
								-- end
							-- elseif curEra == 1 then
								-- if randType == 1 then
									-- ranUnitType = "UNIT_SPEARMAN";
								-- elseif randType == 2 then
									-- ranUnitType = "UNIT_HORSEMAN";
								-- elseif randType == 3 then
									-- ranUnitType = "UNIT_SWORDSMAN";
								-- elseif randType == 4 then
									-- ranUnitType = "UNIT_CATAPULT";
								-- else
									-- ranUnitType = "UNIT_ARCHER";
								-- end
							-- elseif curEra == 4 or curEra == 5 then
								-- if randType == 1 then
									-- ranUnitType = "UNIT_MUSKETMAN";
								-- elseif randType == 2 then
									-- ranUnitType = "UNIT_FIELD_CANNON";
								-- elseif randType == 3 then
									-- ranUnitType = "UNIT_BOMBARD";
								-- elseif randType == 4 then
									-- ranUnitType = "UNIT_CAVALRY";
								-- else
									-- ranUnitType = "UNIT_MUSKETMAN";
								-- end
							-- elseif curEra == 5 or curEra == 6 then
								-- if randType == 1 then
									-- ranUnitType = "UNIT_INFANTRY";
								-- elseif randType == 2 then
									-- ranUnitType = "UNIT_TANK";
								-- elseif randType == 3 then
									-- ranUnitType = "UNIT_RANGER";
								-- elseif randType == 4 then
									-- ranUnitType = "UNIT_ARTILLERY";
								-- else
									-- ranUnitType = "UNIT_INFANTRY";
								-- end
							-- elseif curEra > 6 then
								-- if randType == 1 then
									-- ranUnitType = "UNIT_INFANTRY";
								-- elseif randType == 2 then
									-- ranUnitType = "UNIT_TANK";
								-- elseif randType == 3 then
									-- ranUnitType = "UNIT_RANGER";
								-- elseif randType == 4 then
									-- ranUnitType = "UNIT_ARTILLERY";
								-- else
									-- ranUnitType = "UNIT_INFANTRY";
								-- end
							-- else 
								-- if randType == 1 then
									-- ranUnitType = "UNIT_SLINGER";
								-- elseif randType == 2 then
									-- ranUnitType = "UNIT_HEAVY_CHARIOT";
								-- else
									-- ranUnitType = "UNIT_WARRIOR";
								-- end
							-- end

							-- newArmyUnit = {
								-- unitType = ranUnitType,
								-- xp = ranXP,
							-- }
							-- table.insert(newArmyGroup, 2, newArmyUnit);
							-- table.insert(ExposedMembers.armyGroups, 1, newArmyGroup);
						-- end
						-- if curEra >= 1 then
							-- for i=1,unitNumberSupport do
								-- randType = math.random(1,2);
								-- if curEra == 4 or curEra == 5 then
									-- if randType == 1 then
										-- ranUnitType = "UNIT_MEDIC";
									-- else
										-- ranUnitType = "UNIT_MILITARY_ENGINEER";
									-- end
								-- elseif curEra == 5 or curEra == 6 then
									-- if randType == 1 then
										-- ranUnitType = "UNIT_MEDIC";
									-- else
										-- ranUnitType = "UNIT_OBSERVATION_BALLOON";
									-- end
								-- elseif curEra > 6 then
									-- if randType == 1 then
										-- ranUnitType = "UNIT_MOBILE_SAM";
									-- else
										-- ranUnitType = "UNIT_OBSERVATION_BALLOON";
									-- end
								-- else 
									-- if randType == 1 then
										-- ranUnitType = "UNIT_BATTERING_RAM";
									-- else
										-- ranUnitType = "UNIT_SIEGE_TOWER";
									-- end
								-- end
								-- newArmyUnit = {
									-- unitType = ranUnitType,
									-- xp = 0,
								-- }
								-- table.insert(newArmyGroup, 2, newArmyUnit);
								-- table.insert(ExposedMembers.armyGroups, 1, newArmyGroup);
							-- end
						-- end
						-- armyMoveTracker = {
							-- iUnit = newUnit,
							-- x = x,
							-- y = y,
						-- }
						-- table.insert(ExposedMembers.armyTracker, 1, armyMoveTracker);
					-- end
				-- end
	-- end
-- end 


Events.UnitMoved.Add(				OnUnitMoved );
LuaEvents.GetMyGlobals.Add(GetMyGlobals);
Events.UnitRemovedFromMap.Add( OnUnitRemovedFromMap );
--Events.PlayerTurnActivated.Add(OnPlayerTurnActivated)


function Initialize()
	ExposedMembers.armyGroups = {};
	ExposedMembers.armyTracker = {};
	armyTable = GameConfiguration.GetValue ("armyTable");
	print(armyTable);
	if armyTable ~= nil then
		ExposedMembers.armyGroups = {};
		for i in string.gmatch(armyTable, "[^!]*") do
		   
		   if i ~= "" and i ~= "!" then
				print("i = " .. i);
				for j in string.gmatch(i, "[^@]*") do
					if j ~= "" then
						j = tonumber(j);
						if j ~= nil then
							print("j = " .. j);
							newArmyGroup = {j};
						end
					end
				end
				for k in string.gmatch(i, "[^#]*") do
					if k ~= "" then
						if(k:match("^[a-zA-Z0-9_]*$")) then
							print("k = " .. k);
							newUnitType = k;
						end
					end
				end
				for l in string.gmatch(i, "[^$]*") do
					if l ~= "" then
						l = tonumber(l);
						if l ~= nil then
							print("l = " .. l);
							newUnitXP = l;
						end
					end
				end
				newArmyUnit = {
					unitType = newUnitType,
					xp = newUnitXP,
				}
				table.insert(newArmyGroup, 2, newArmyUnit);
				table.insert(ExposedMembers.armyGroups, 1, newArmyGroup);
				
			end
			
		end
		armyTrackerTable = GameConfiguration.GetValue ("armyTrackerTable");
		print(armyTrackerTable);
		if armyTrackerTable ~= nil then
			for i in string.gmatch(armyTrackerTable, "[^!]*") do
				if i ~= "" and i ~= "!" then
					for j in string.gmatch(i, "[^@]*") do
						if j ~= "" then
							j = tonumber(j);
							if j ~= nil then
								print("j = " .. j);
								iUnit = {j};
							end
						end
					end
					for k in string.gmatch(i, "[^#]*") do
						if k ~= "" then
							k = tonumber(k);
							if k ~= nil then
								print("k = " .. k);
								x = k;
							end
						end
					end
					for l in string.gmatch(i, "[^$]*") do
						if l ~= "" then
							l = tonumber(l);
							if l ~= nil then
								print("l = " .. l);
								y = l;
							end
						end
					end
				end
			end
		end
			--newArmyGroup = {newUnit};
			--unitType = GameInfo.Units[pUnit:GetUnitType()].UnitType;
			--newArmyUnit = {
			--	unitType = unitType,
			--	xp = experience,
			--}
			-- GET NAME AND PROMOTIONS ALSO
			--table.insert(newArmyGroup, 2, newArmyUnit);
			--table.insert(ExposedMembers.armyGroups, 1, newArmyGroup);
		--Get all values then store into exposed Members
	end

	
	
end
Initialize();